/* BACKUP.H:  Header file for backup.
 *
 * $Header: /cd/ua/sam/src/ss/backup/RCS/backup.h,v 1.3 89/06/09 16:06:30 sam REL-6-9-89 $
 *
 * $Log:	backup.h,v $
 * Revision 1.3  89/06/09  16:06:30  sam
 * Got rid of SENDSIZE re-definition.
 * 
 * Revision 1.2  89/04/03  21:48:30  sam
 * *** empty log message ***
 * 
 * Revision 1.1  89/03/08  20:49:10  sam
 * Initial revision
 * 
 */

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 64
#endif

typedef enum {INC, FULL} SAVETYPES;

struct machrec {
    char *name;			/* Hostname */
};

struct saverec {
    SAVETYPES type;		/* Type of save */
    char days[7];		/* Map of which days the save will take place */
    int npaths;			/* Number of paths */
    char **paths;		/* The paths to be saved */
    char *tape_name;		/* Name of the tape */
    struct machrec *mach;	/* Descripton of machine this save is on */
};

typedef union {
    int num;
    char *label;
    SAVETYPES stypes;
} YYSTYPE;

/* DEFTAPEDEV: Default name of the tape device.
 */
#define DEFTAPEDEV "/dev/rst8"

/* DEF_SAVE_FORMAT: Default save format string.
 */
#define DEF_SAVE_FORMAT "%h-%s-%t-%d"

/* DEF_BLK_SIZE: Default block size.
 */
#define DEF_BLK_SIZE 64512

/* DEF_BYTES_PER_TAPE: Default number of bytes per tape.
 */
#define DEF_BYTES_PER_TAPE (30000*DEF_BLK_SIZE)

/* DATAFILE: File to hold dumpdates of partitions on the backup server.
 */
#define DATAFILE "/usr/local/etc/ss/dumpdates"

/* CONFIGFILE: Name of the configuration file
 */
#define CONFIGFILE "/usr/local/etc/ss/config"

/* STAND_RCMD: The saver to be executed on the remote machine.  Must be in 
 * the same place on all machines.
 */
#define STAND_RCMD "/usr/local/etc/ss/saver -c -i core"

/* MAIL_CMD: Command to send mail -- will be followed by addresses to send to.
 */
#define MAIL_CMD "/usr/local/mhmail -subject backup-output"

/* Errors that can happen during the save */
#define CP_OK		0
#define CP_ERR_RD	1
#define CP_ERR_WR	2
#define CP_ERR_OTHER	3
#define CP_ERR_TIME	4
#define CP_CONT		5	/* These last two are used internally */
#define CP_CHANGE	6	/* by fast_copy only. */

/* Choices the operator can make after an error */
#define CH_NEW		0
#define CH_RETRY	1
#define CH_SKIP		2
#define CH_ABORT	3

/* Reading and writing ends of a pipe */
#define R_END 0
#define W_END 1
