%{
/*******************************************************************/
/*      Copyright (C) 1989 by                                      */
/*            The Regents of the University of California          */
/*                                                                 */
/*                             DISCLAIMER                          */
/*                                                                 */
/*      "Although   each   program   has   been  tested  by  its   */
/*      contributor, no warranty, express or implied, is made by   */
/*      the  contributor  or the University of California, as to   */
/*      the accuracy and functioning of the program and  related   */
/*      program material, nor shall the fact of the distribution   */
/*      constitute any such warranty, and no  responsibility  is   */
/*      assumed   by   the  contributor  or  the  University  of   */
/*      California in connection herewith."                        */
/*******************************************************************/

/* LEXER.L: Lexer for the config file
 *
 * $Header: /cd/ua/sam/src/ss/backup/RCS/lexer.l,v 1.3 89/06/09 16:09:09 sam REL-6-9-89 $
 *
 * $Log:	lexer.l,v $
 * Revision 1.3  89/06/09  16:09:09  sam
 * No changes.
 * 
 * Revision 1.2  89/04/03  21:49:35  sam
 * No changes
 * 
 * Revision 1.1  89/03/08  20:49:54  sam
 * Initial revision
 * 
 */
#ifndef lint
static char rcsid[] = "$Header: /cd/ua/sam/src/ss/backup/RCS/lexer.l,v 1.3 89/06/09 16:09:09 sam REL-6-9-89 $";
#endif
%}

a	[aA]
b	[bB]
c	[cC]
d	[dD]
e	[eE]
f	[fF]
g	[gG]
h	[hH]
i	[iI]
j	[jJ]
k	[kK]
l	[lL]
m	[mM]
n	[nN]
o	[oO]
p	[pP]
q	[qQ]
r	[rR]
s	[sS]
t	[tT]
u	[uU]
v	[vV]
w	[wW]
x	[xX]
y	[yY]
z	[zZ]
W	[ \t\n]
L	[A-Za-z\_\/\%\$\#\.\,\;\:\=\-]
E	[A-Za-z0-9\_\/\%\$\#\.\,\;]
%{

#include "../global.h"
#include "backup.h"
#include "y.tab.h"

extern YYSTYPE yylval;
#define LVALSTR (yylval.label)

%}
%%
\#.*					;
{m}{a}{i}{l}				return T_MAIL;
{d}{a}{t}{a}_{f}{i}{l}{e}		return T_DATA_FILE;
{t}{i}{m}{e}{o}{u}{t}			return T_TIMEOUT;
{s}{a}{v}{e}_{n}{a}{m}{e}		return T_SAVE_NAME;
{s}{e}{t}{s}				return T_SETS;
{s}{a}{v}{e}{l}{i}{s}{t}{d}{i}{r}	return T_SAVELISTDIR;
{t}{a}{p}{e}{d}{e}{v}			return T_TAPEDEV;
{m}{a}{c}{h}{i}{n}{e}			return T_MACHINE;
{f}{u}{l}{l}{s}{a}{v}{e}		return T_FULLSAVE;
{i}{n}{c}{r}{e}{m}{e}{n}{t}{a}{l}	return T_INCREMENTAL;
{p}{a}{t}{h}{s}?			return T_PATH;
{t}{a}{p}{e}				return T_TAPE;
{w}{h}{e}{n}				return T_WHEN;
{s}{u}{n}				return T_SUN;
{m}{o}{n}				return T_MON;
{t}{u}{e}				return T_TUE;
{w}{e}{d}				return T_WED;
{t}{h}{u}				return T_THU;
{f}{r}{i}				return T_FRI;
{s}{a}{t}				return T_SAT;
[0-9]+					{   yylval.num = atoi(yytext);
					    return T_NUMBER;
					}
\/{L}*{E}*				{ LVALSTR = yytext; return T_PATHNAME; }
{L}*{E}+				{ LVALSTR = yytext; return T_TEXT; }
\"[^"]*\"				{    LVALSTR = yytext+1;
					     yytext[yyleng-1]=0;
					     return T_TEXT; }
{W}+					;
.					return yytext[0];
%%

#ifdef TEST
YYSTYPE yylval;
main()
{
    int i;

    while (i = yylex()) {
	printf("lex # is %d", i);
	if (i == T_PATHNAME || i == T_TEXT)
	    printf("yylval is %s", LVALSTR);
	putchar('\n');
    }
}
#endif TEST
